import "./cljs_env.js";
goog.provide('longdown.cli');
longdown.cli.cli_options = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-d","--out-dir DIR","Output directory"], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-h","--help"], null)], null);
longdown.cli.usage = (function longdown$cli$usage(options_summary){
return clojure.string.join.cljs$core$IFn$_invoke$arity$2("\n",new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Convert longform markdown files to outline format used by Logseq","","Usage: longdown [options] file.md...","       longdown -","","When file is -, reads standard input and prints to standard output.","","Options:",options_summary], null));
});
longdown.cli.convert_files = (function longdown$cli$convert_files(out_dir,filenames){
var seq__21862 = cljs.core.seq(filenames);
var chunk__21863 = null;
var count__21864 = (0);
var i__21865 = (0);
while(true){
if((i__21865 < count__21864)){
var in_path = chunk__21863.cljs$core$IIndexed$_nth$arity$2(null,i__21865);
var out_path_21912 = shadow.esm.esm_import$node_path.join(out_dir,in_path);
shadow.esm.esm_import$node_fs.mkdirSync(shadow.esm.esm_import$node_path.dirname(out_path_21912),({"recursive": true}));

longdown.lib.spit(out_path_21912,longdown.lib.longform__GT_outline(longdown.lib.slurp(in_path)));


var G__21913 = seq__21862;
var G__21914 = chunk__21863;
var G__21915 = count__21864;
var G__21916 = (i__21865 + (1));
seq__21862 = G__21913;
chunk__21863 = G__21914;
count__21864 = G__21915;
i__21865 = G__21916;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__21862);
if(temp__5804__auto__){
var seq__21862__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__21862__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__21862__$1);
var G__21917 = cljs.core.chunk_rest(seq__21862__$1);
var G__21918 = c__5568__auto__;
var G__21919 = cljs.core.count(c__5568__auto__);
var G__21920 = (0);
seq__21862 = G__21917;
chunk__21863 = G__21918;
count__21864 = G__21919;
i__21865 = G__21920;
continue;
} else {
var in_path = cljs.core.first(seq__21862__$1);
var out_path_21921 = shadow.esm.esm_import$node_path.join(out_dir,in_path);
shadow.esm.esm_import$node_fs.mkdirSync(shadow.esm.esm_import$node_path.dirname(out_path_21921),({"recursive": true}));

longdown.lib.spit(out_path_21921,longdown.lib.longform__GT_outline(longdown.lib.slurp(in_path)));


var G__21923 = cljs.core.next(seq__21862__$1);
var G__21924 = null;
var G__21925 = (0);
var G__21926 = (0);
seq__21862 = G__21923;
chunk__21863 = G__21924;
count__21864 = G__21925;
i__21865 = G__21926;
continue;
}
} else {
return null;
}
}
break;
}
});
longdown.cli.convert_from_stdin = (function longdown$cli$convert_from_stdin(){
return cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([clojure.string.trim_newline(longdown.lib.longform__GT_outline(longdown.lib.slurp(process.stdin.fd)))], 0));
});
longdown.cli._main = (function longdown$cli$_main(var_args){
var args__5775__auto__ = [];
var len__5769__auto___21927 = arguments.length;
var i__5770__auto___21929 = (0);
while(true){
if((i__5770__auto___21929 < len__5769__auto___21927)){
args__5775__auto__.push((arguments[i__5770__auto___21929]));

var G__21930 = (i__5770__auto___21929 + (1));
i__5770__auto___21929 = G__21930;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return longdown.cli._main.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(longdown.cli._main.cljs$core$IFn$_invoke$arity$variadic = (function (args){
var map__21900 = clojure.tools.cli.parse_opts(args,longdown.cli.cli_options);
var map__21900__$1 = cljs.core.__destructure_map(map__21900);
var options = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21900__$1,new cljs.core.Keyword(null,"options","options",99638489));
var arguments$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21900__$1,new cljs.core.Keyword(null,"arguments","arguments",-1182834456));
var summary = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21900__$1,new cljs.core.Keyword(null,"summary","summary",380847952));
var map__21901 = options;
var map__21901__$1 = cljs.core.__destructure_map(map__21901);
var out_dir = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21901__$1,new cljs.core.Keyword(null,"out-dir","out-dir",-939021234));
if(cljs.core.truth_((function (){var or__5045__auto__ = new cljs.core.Keyword(null,"help","help",-439233446).cljs$core$IFn$_invoke$arity$1(options);
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return cljs.core.empty_QMARK_(arguments$);
}
})())){
return cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([longdown.cli.usage(summary)], 0));
} else {
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(arguments$),(1))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(arguments$),"-")))){
return longdown.cli.convert_from_stdin();
} else {
if((out_dir == null)){
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Output directory is required"], 0));

return process.exit((1));
} else {
return longdown.cli.convert_files(out_dir,arguments$);

}
}
}
}));

(longdown.cli._main.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(longdown.cli._main.cljs$lang$applyTo = (function (seq21895){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq21895));
}));


//# sourceMappingURL=longdown.cli.js.map
